function [ mutated_Individual_array ] = mutate( Individual_array , p )
%MUTATE mutate single character



%set default p mutation if not given by user

if nargin == 1
    p = 0.2;
end

chrompack_array= [Individual_array.chrompack];

preallocated_chroms(1,length(Individual_array)) = Chrompack();

for i = 1:length(chrompack_array)

preallocated_chroms(i) = mutate_chrom(chrompack_array(i),p);

end

mutated_Individual_array = individualize(preallocated_chroms);

end





function [ mutated_chrompack ] = mutate_chrom( chrompack , p )



%MUTATE mutate single character

%input --> chrompack
%output --> chrompack


%mutate single bit only if favorable biased coin toss
if not(randi([0,floor(1/p)]))
    genome = chrompack.genome;
    randompos = randi(numel(genome));
    genome(randompos) = not(genome(randompos));
    mutated_chrompack = Chrompack(genome);
else
    mutated_chrompack = chrompack;


end
end
