classdef Chrompack
    
    
    properties
        genome
    end
    
    methods
        function r  = individualize(chrompacks)
            individuals = (arrayfun(@(x)Individual(x), chrompacks , 'UniformOutput',false));
            r = [individuals{:}];

        end
        function obj = Chrompack(gen) 
            if nargin               
                obj.genome = gen;
            end 
            
         end
         function r=fitness(obj,fitness_mode_opts)
             r = calculatefitness(obj.genome,fitness_mode_opts);             
        end    
    end
    
end

