function [ fitness ] = calculatefitness( genome , fitness_opts )

    mode = fitness_opts{1};
    

    switch mode
        case 'function_max'
            fitness  = function_max(genome,fitness_opts);
        case 'multiparam_max'   
            fitness = function_max_multipar(genome, fitness_opts);
            
    end
end

function [fitness] = function_max(genome,fitness_opts)
    
    %mode = 'function_max'
    %fitness_opts = {'function_max', a , b , @(x) f(x)}
    
    
    f = fitness_opts{4}; 
    x = decode_ab(genome , length(genome) , fitness_opts{2} , fitness_opts{3});
    fitness = f(x);
end




function [fitness] = function_max_multipar(genome,fitness_opts)
    
    %mode = 'multiparam_max'
    %fitness_opts = {'multiparam_max', a1 ,b1 ,a2 ,b2 , f}
    
    
    f = fitness_opts{6}; 
    x = decode_ab(genome(1,:), length(genome(1,:)), fitness_opts{2}, fitness_opts{3});
    y = decode_ab(genome(2,:), length(genome(2,:)), fitness_opts{4}, fitness_opts{5});
    fitness = f(x,y);
    
    
end