function [ text_line ] = nextline( textfile )
%NEXTLINE read next line of a file, ignores comment lines , blank lines or
%lines starting with an space. terminate read wen END is found


persistent textID;
persistent control;
persistent per_textfile;


% If textID is empty ----> open textfile to set textID
%                    ----> set per_textfile as textfile
if isempty(textID)
    textID = fopen(textfile);
    per_textfile = textfile;
end

%detect changes in textfile
if per_textfile ~= textfile
    error('data file changed')
end
    

control = '%';
%read until non void line or non coment line found and only if no 'END' red
while (strcmp(control , '%') || strcmp(control, '')||strcmp(control, ' ')) && not(strcmp(control,'END'))
     
    %read line
     text_line = fgetl(textID);
     
     %if line void, control = '' 
     %       else , control = text_line's first character (to detect
     %       comment lines)
     if isempty(text_line)
         control  = '';
     else
         control = text_line(1);
     end
               
end

%check if last line 'END', if so close file

if strcmp(text_line , 'END')
    disp(' END line found. Text file will be closed.')
    fclose(textID);
    clear textID
    clear control
    clear per_textfile
end
    








end












