import modules_ga_v10 as mo
import time
import random
from matplotlib import pyplot as plt



print('\n \n ------------- \n \n')

time.sleep(0.5)

random.seed(4)
# print(sum((mo.measure_order(mo.generate_random_list(mo.list_size)) for i in range(200)))/200)




computed_sizes = [4,5, 6, 7, 8, 9, 10]
# ['c', '1-', '1++', 'i', '1+', '0-', '1--', '1-', 'i', '0++']
# ['0-', '0-', 's', '1++', '1-', '1-', '1++', '1--', '1--', '0++']
# ['0--', '0++', '0--', 'c', 'i', '1--', '0++', '0+', '0--', '0-', 's', '1-', '1-', 'c', '0--', 'c', '1+', '0++', '1--', '0+']
# ['s', '0++', '1--', '0+', '1++', '1+', '1+', '1-', '0--', '0--', '0+', 's', '0+', 's', '1+', 's', '0+', '1+', 's', '0++', '0+', '0--', '1--']
# ['1+', '0-', '1-', 's', '1--', '1-', '0+', '1-', '1--', '0+', 's', '0+', '0-', 's', '1+', '0--', 'c', '1+', 'i', '1-', '0--', '0++', '0-', 's', '0-', '1++']
# ['c', '0--', 'c', '0-', '1-', 'c', '0++', '0+', '1+', 'c', '0--', '0-', '1+', '0--', '1+', '0-', '1++', '0-', '0--', '0++', 's', '0+', 'c', '1-', 'c', '1-', '0-',
#'0-', '1--', 's', '1--', '1++', 'i', '1++', '0--', '0--', '1--', '0++', '0--', '0+', '1--', '1--', '0--', '1--', '0--', '0--', '0--', '0--', '1+', '0--']
# ['1-', '1+', '1--', '0+', '1+', 'c', '1+', '0-', '1-', '1-', '0--', '0--', 's', 's', '1-', '0++', '0+', 'c', '1--', '0-', '0-', '1+', '1+', 'c', 's', '1++', '0++',
#'1-', '1--', '1--', '1-', '0++', 'c', '1-', '1--', 's', '1++', 's', '1-', '1++', '0+', 'c', '0++', '0--', 'c', '1-', '1--', '0+', '1-', '1--', '0--', '1--', '0++',
#'0-', '1--', 'c', '1--', '0-', '1++', '0--']
mean_pstep_count_hist = [3.526,  7.2835, 13.2014, 20.5113, 26.8551, 47.6345, 70.3024]
mean_qstep_count_hist = [4.8446, 7.3829, 10.2942, 13.4719, 16.9368, 20.5831, 24.4349]
mean_istep_count_hist = [2.9961, 5.0081, 7.4823,  10.5419, 13.8817, 18.0272, 22.5761]
max_pstep_count_hist =  [5,      10,     19,      25,      37,      71,      96]
max_qstep_count_hist =  [6,      10,     15,      21,      28,      36,      44]
max_istep_count_hist =  [6,      10,     15,      21,      27,      35,      41]


plt.plot(computed_sizes,max_pstep_count_hist, color = '#0004ff', label='GP maximun')

plt.plot(computed_sizes,max_qstep_count_hist, color = '#ff0505', label='quicksort maximun')

plt.plot(computed_sizes,max_istep_count_hist, color = '#1bb628', label='insertion sort maximun')

plt.plot(computed_sizes,mean_pstep_count_hist, color = '#9ea0ff', label='GP mean')

plt.plot(computed_sizes,mean_qstep_count_hist, color = '#ff7575', label='quicksort mean')

plt.plot(computed_sizes,mean_istep_count_hist, color = '#83ec8c', label='insertion sort mean')

plt.xticks(computed_sizes)

plt.legend()

plt.xlabel('List size')

plt.ylabel('Number of comparisons')



plt.show()




# uncomment to perform search
#mo.get_comp_number_data()

